<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Twitter OAuth sample</title>
</head>
<body>
<h1>Twitter OAuth sample</h1>

<?php

//セッションスタート
session_start();

//コールバックURLを設定
$url = '登録したコールバックURL';

//consumer_keyを設定
$consumer_key = '取得したconsumer_key';

//consumer_secretを設定
$consumer_secret = '取得したconsumer_secret';

//HTTP_OAuthライブラリを読み込む
include 'HTTP/OAuth/Consumer.php';

//HTTP_OAuthを利用するための各種設定
$consumer = new HTTP_OAuth_Consumer($consumer_key, $consumer_secret);
$http_request = new HTTP_Request2();
$http_request->setConfig('ssl_verify_peer', false);
$consumer_request = new HTTP_OAuth_Consumer_Request;
$consumer_request->accept($http_request);
$consumer->accept($consumer_request);

//Twitter認証済みかチェック
if( isset($_SESSION['access_token']) ){
  //認証済みの場合
  
  //状態チェック
  if( isset($_GET['logout']) ){
    //ログアウトする場合
    if($_GET['logout'] == 'on'){
      //セッションを破棄する
      session_destroy();
      //ログアウト表示
      echo '<a href="'.$url.'">ログアウトしました。ここをクリックしてください。</a>';
    }
  }else if( isset($_POST['q']) && ($_POST['q'] != "") ){
    //フォームからつぶやきが投稿されていた場合
    //保存しておいたアクセストークンを読み出して設定する
    $consumer->setToken($_SESSION['access_token']);
    $consumer->setTokenSecret($_SESSION['access_token_secret']);
    
    //つぶやき内容を設定
    $status = $_POST['q'];
    
    //APIを利用してツイッターに投稿
    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/update.xml", array('status' => $status), "POST");
    
    //レスポンスXMLを解析する
    $xml = simplexml_load_string($response->getBody());
    if(isset($xml->id)){
      //無事投稿できていたら、投稿内容を確認するリンクを表示
      echo '<a href="http://twitter.com/'.$xml->user->screen_name.'/status/'.$xml->id.'">投稿内容を確認する</a>';
    }else{
      //投稿できなかった場合はエラー表示
      echo 'うまく投稿できなかったようです。<br>';
      echo $response->getBody();
    }
  }else{
    //それ以外の場合
    //つぶやきフォームを表示
    echo <<<postform
<p>いまどうしてる？</p>
<form method="POST" action="twitter_oauth.php">
<input type="text" name="q" size="80">
<input type="submit" value="ツイート">
</form>
<p><a href="twitter_oauth.php?logout=on">ログアウトしたい場合はこちら</a></p>
postform;

    //保存しておいたアクセストークンを読み出して設定する
    $consumer->setToken($_SESSION['access_token']);
    $consumer->setTokenSecret($_SESSION['access_token_secret']);
  
    //APIを利用してホームタイムラインを取得
    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/home_timeline.xml", array('count' => '20'), "GET");
    
    //ユーザータイムラインを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/user_timeline.xml", array('count' => '20','screen_name' => 'zapa'), "GET");
    
    //APIを利用してmentionsを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/mentions.xml", array('count' => '20'), "GET");
    
    //APIを利用してあなたのリツイートを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/retweeted_by_me.xml", array('count' => '20'), "GET");
    
    //APIを利用してみんなのリツイートを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/retweeted_to_me.xml", array('count' => '20'), "GET");
    
    //APIを利用してリツイートされたあなたのツイートを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/statuses/retweets_of_me.xml", array('count' => '20'), "GET");
    
    //APIを利用してお気に入りを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/favorites.xml", array('id' => 'zapa'), "GET");
    
    //APIを利用してリストを取得
//    $response = $consumer->sendRequest("http://api.twitter.com/1/amntwit/lists/amnpartnerlist/statuses.xml", array('per_page' => '20'), "GET");
    
    //レスポンスXMLを解析する
    $xml = simplexml_load_string($response->getBody());
    if(isset($xml->status->id)){
      //無事取得できていたら、内容を表示する
      foreach($xml->status as $status){
        echo '<img src="'.$status->user->profile_image_url.'" width=48 height=48> ';
        echo '<a href="http://twitter.com/'.$status->user->screen_name.'">'.$status->user->screen_name.'</a>:';
        echo $status->text;
        echo ' <a href="http://twitter.com/'.$status->user->screen_name.'/status/'.$status->id.'">'.$status->created_at."</a><br>\n";
      }
    }else{
      //投稿できなかった場合はエラー表示
      echo 'うまく取得できなかったようです。<br>';
      echo '<pre>'.htmlspecialchars($response->getBody(), ENT_QUOTES).'</pre>';
    }
  }
}else{
  //認証済みでない場合
  
  //Twitterからのコールバックかチェック
  if( isset($_GET['oauth_verifier']) ){
    //Twitterからのコールバックの場合
    //oauth_verifierを取得する
    $verifier = $_GET['oauth_verifier'];
    
    //保存しておいたリクエストトークンを読み出して設定する
    $consumer->setToken($_SESSION['request_token']);
    $consumer->setTokenSecret($_SESSION['request_token_secret']);
    
    //アクセストークンを取得する
    $consumer->getAccessToken('https://twitter.com/oauth/access_token', $verifier);
    
    //アクセストークンをセッションに保存
    $_SESSION['access_token'] = $consumer->getToken();
    $_SESSION['access_token_secret'] = $consumer->getTokenSecret();
    
    //認証完了表示
    echo '<a href="'.$url.'">認証完了。ここをクリックしてください。</a>';
    
  }else{
    //認証済みでなく、Twitterからのコールバックでもない場合
    //リクエストトークンを取得
    $callback = $url;
    $consumer->getRequestToken('https://twitter.com/oauth/request_token', $callback);
    
    //リクエストトークンをセッションに保存
    $_SESSION['request_token'] = $consumer->getToken();
    $_SESSION['request_token_secret'] = $consumer->getTokenSecret();
    
    //認証用URLを取得
    $auth_url = $consumer->getAuthorizeUrl('https://twitter.com/oauth/authorize');
    
    //認証用URLのリンクを表示
    echo '<a href="'.$auth_url.'">Twitterで認証する</a><br>';
  }
}

?>
<hr>
</body>
</html>