<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>間違い.net API サンプル</title>
</head>
<body>
<h1>間違い.net API サンプル</h1>
<?php
//送信されたワードがあるかチェックする
if( isset($_GET['q']) && ($_GET['q'] != "") ){
  //検索キーワードを設定する
  $keyword   = $_GET['q'];
  
  //ウェブ表示用キーワードを設定する
  $q = htmlspecialchars($keyword,ENT_QUOTES);
  
  //APIリクエストURLを生成する
  $requrl = "http://api.machigai.net/word/".urlencode($keyword);
  
  //XMLファイルをパースし、オブジェクトに代入する
  $data = simplexml_load_file($requrl);
  
  //誤ワードが見つかったかチェックする
  if( isset($data->data->sei) ){
    //誤ワードが見つかった場合
    $goword  = $data->data->go;      // 誤ワード
    $seiword = $data->data->sei;     // 正ワード
    $url     = $data->data->url;     // 該当URL（サイトがある場合）
    $gourl   = $data->data->gourl;   // 間違い.net 誤ワードURL
    $seiurl  = $data->data->seiurl;  // 間違い.net 正ワードURL
    
    //誤ワードを表示する
    echo "もしかして、 「<strong>".$seiword."</strong>」 ではありませんか？<br>";
    echo "　<a href=\"?q=".urlencode($seiword)."\">「{$seiword}」で検索し直す場合はこちら</a><br>";
    
    //該当URLがある場合
    if($url != ""){
       print "<br><a href='{$url}'>{$seiword}webサイトはこちら</a><br>";
    }
    
    //間違い.netへのリンクを表示する
    echo "<br>";
    echo "<a href='{$gourl}'>間違い.net 誤ワードページへ</a><br>";
    echo "<a href='{$seiurl}'>間違い.net 正ワードページへ</a><br>";
  }
  
  //Yahoo!ブログ検索からRSSを取得する
  $rssurl = "http://blog-search.yahoo.co.jp/rss?ei=UTF-8&p=".urlencode($keyword);
  
  //XMLファイルをパースし、オブジェクトに代入する
  $rssdata = simplexml_load_file($rssurl);
  
  //Yahoo!ブログ検索の結果を表示する
  echo "<h2><strong>".$q."</strong>でブログ検索した結果</h2>";
  
  //返り値をチェックする
  if($rssdata){
    //データが正常の場合
    echo "<dl>";
    
    //item数だけ繰り返す
    foreach ($rssdata->channel->item as $item) {
      //タイトルとリンク、概要を表示する
      echo "<dt><a href=\"".$item->link."\">".$item->title."</a></dt>";
      echo "<dd>".$item->description."</dd>";
    }
    echo "</dl>";
  }else{
    //データが見つからなかった場合
    echo "<p>見つかりませんでした。</p>";
  }
}else{
  // 検索ワードが未入力の場合
  echo "<p>検索ワードを入力してください。</p>";
}
?>
<form method="GET" action="machigai.php">
<input type="text" name="q" size="80">
<input type="submit" value="送信"></p>
</form> 
<p>検索協力：<a href="http://www.machigai.net/">間違い.net</a></p>
</body>
</html>