<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>出演者検索API サンプル</title>
</head>
<body>
<h1>出演者検索API サンプル</h1>
<hr>
<?php

//出演者名が入力されているかチェックする
if(isset($_POST['cast'])){
  //発行されたAPIキー
  $key = '取得したAPIキーを入力してください';
  
  //検索文字列
  $cast = urlencode(mb_convert_encoding($_POST['cast'],"SJIS","UTF-8"));

  //開始日時(YYYYMMDD)
  $period_start = "20080101";

  //終了日時(YYYYMMDD)
  $period_end = date("Ymd");

  //リクエストURLを生成する
  $url = 'http://appli.ntv.co.jp/ntv_WebAPI/program/?'.
      'key='.$key.
      '&cast='.$cast.
      '&period_start='.$period_start.
      '&period_end='.$period_end;
  
  //XMLファイルをパースし、オブジェクトに代入する
  $xml = simplexml_load_file($url);
  
  //返り値をチェックする
  if($xml){
    //見つかった件数を表示
    echo "<p>".$xml->hit_count."件見つかりました。</p>\n";
    
    //件数分繰り返す
    foreach($xml->program as $program){
      
      //検索結果内容を表示する
      echo '<h2><a href="'.$program->url.'">'.$program->title.'</a></h2>';
      echo '放送日時：'.$program->airtime.'<br>';
      echo '出演者一覧：'.$program->castlist.'<br>';
      echo '番組概要：'.$program->synopsis.'<br>';
    }
  }else{
    //simplexml_load_file関数のパース時にエラーが発生した場合
    echo "エラー発生";
  }
}

?>

<p>検索したい出演者名を入力してください。</p>
<form method="POST" action="ntv.php">
<input type="text" name="cast" size="80">
<input type="submit" value="送信"></p>
</form> 
<p>Powered by <a href="http://www.ntv.co.jp/appli/">日テレアプリ</a></p>
</body>
</html>