<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
 "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Amazon Product Advertising API サンプル</title>
</head>
<body>
<h1>Amazon Product Advertising API サンプル</h1>
<hr>
<?php
//Product Advertising APIを利用して、商品を検索してHTMLタグを返す関数
function search_paa($SearchIndex,$keyword){
  //Your Access Key ID
  $AccessKeyID = "取得したAccess Key ID";

  //Your Secret Access Key
  $SecretAccessKey = "取得したSecret Access Key";

  //ベースURL
  $method = "GET";
  $host = 'webservices.amazon.co.jp';
  $uri = "/onca/xml";

  //パラメータ設定
  $params['AWSAccessKeyId'] = $AccessKeyID;
  $params['Service']        = 'AWSECommerceService';
  $params['Version']        = '2009-11-01';
  $params['Operation']      = 'ItemSearch';
  $params['ResponseGroup']  = 'Small,Images';
  $params['SearchIndex']    = $SearchIndex;
  $params['Keywords']       = $keyword;
  $params['AssociateTag']   = "取得したアソシエイトID";
  $params['Timestamp'] = gmdate('Y-m-d\TH:i:s\Z');

  // パラメータの順序を昇順に並び替え
  ksort($params);

  //正規化されたリクエストを作成
  $query = array();

  foreach ($params as $param=>$value){
    //RFC 3986形式に変換してエンコード
    $param = str_replace("%7E", "~", rawurlencode($param));
    $value = str_replace("%7E", "~", rawurlencode($value));
    $query[] = $param."=".$value;
  }

  //&でつなぐ
  $query = implode("&", $query);

  //指定された形式で署名を作成
  //RFC2104準拠のHMAC-SHA256ハッシュアルゴリズムの計算とbase64エンコード
  $Signature = $method."\n".$host."\n".$uri."\n".$query;
  $Signature = base64_encode(hash_hmac("sha256", $Signature, $SecretAccessKey, True));
  $Signature = str_replace("%7E", "~", rawurlencode($Signature));

  //リクエストURLを作成
  $url = "http://".$host.$uri."?".$query."&Signature=".$Signature;

  //返り値を初期化
  $ret = "";

  //XMLをパース
  $xml = simplexml_load_file($url);

  //エラーチェック
  if($xml === false){
      return false;
  }else{
    //取得できた数だけループ処理
    foreach($xml->Items->Item as $Item){
      $ret .= '<a href="'.$Item->DetailPageURL.'"><img src="'.$Item->MediumImage->URL."\"></a><br>\n";
      $ret .= '<a href="'.$Item->DetailPageURL.'">'.$Item->ItemAttributes->Title."</a><br>\n";
    }
  }
  return $ret;
}
//指定した商品カテゴリー、キーワードで検索して表示
echo search_paa("Books","工学社");
?>
<hr><p>powerd by Amazon Product Advertising API</p>
</body>
</html>