<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>ジオコーダ API サンプル</title>
</head>
<body>
<h1>ジオコーダ API サンプル</h1>
<?php
//送信されたキーワードがあるかチェックする
if( isset($_GET['q']) && ($_GET['q'] != "") ){
  //検索キーワードを設定する
  $query = $_GET['q'];
  
  //アプリケーションIDを設定する
  $appid = "取得したアプリケーションID";
  
  //APIリクエストURLを生成する
  $requrl = "http://geo.search.olp.yahooapis.jp/OpenLocalPlatform/V1/geoCoder?"
            ."appid=".$appid
            ."&query=".urlencode($query)
            ."&ei="."UTF-8"
            ."&output="."xml";
  
  //XMLファイルをパースし、オブジェクトに代入する
  $data = simplexml_load_file($requrl);
  
  //住所情報が見つかったかチェックする
  if( isset($data->ResultInfo->Count) ){
    //住所情報が見つかった場合
    $coordinates = $data->Feature->Geometry->Coordinates;
    
    //緯度経度情報を取得し、緯度と経度に分ける
    $latlon = explode(",", $coordinates);
    
    //緯度と経度を表示する
    echo '<h2>「'.htmlspecialchars($query,ENT_QUOTES).'」の検索結果</h2>';
    echo '<ul><li>経度：'.$latlon[0].'</li>';
    echo '<li>緯度：'.$latlon[1].'</li></ul>';
    
    //スタティックマップAPIを使い、地図を表示する
    echo '<img width="480" height="320" src="http://map.olp.yahooapis.jp/OpenLocalPlatform/V1/static?appid='.$appid
         .'&lat='.$latlon[1].'&lon='.$latlon[0].'&z=16&width=480&height=320&pointer=on">';
  }else{
    //位置情報が見つからなかった場合
    echo "<p>位置情報が見つかりませんでした。<br>正しい住所を入力してください。</p>";
  }
}
?>
<p>下記フォームに住所を入力して送信してください。<br>位置情報（緯度、経度）を調べて表示します。</p>
<form method="GET" action="geocoder.php">
<input type="text" name="q" size="80">
<input type="submit" value="送信"></p>
</form> 
<hr>
<!-- Begin Yahoo! JAPAN Web Services Attribution Snippet -->
<span style="margin:15px 15px 15px 15px"><a href="http://developer.yahoo.co.jp/about">Webサービス by Yahoo! JAPAN</a></span>
<!-- End Yahoo! JAPAN Web Services Attribution Snippet -->
</body>
</html>